<?php

namespace adriweb\ub\GermGranBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Session\Session;

use adriweb\ub\GermGranBundle\Entity\Tr;
use adriweb\ub\GermGranBundle\Entity\UserTr;

require_once 'google/google-api-php-client/src/Google_Client.php';
require_once 'google/google-api-php-client/src/contrib/Google_DriveService.php';

class ListController extends Controller
{
    public function indexAction(Request $request)
    {
    	
    	$session = $request->getSession();
    	$session->start();
    	
    	if($session->get('userId')){
    		
    		$em = $this->getDoctrine()->getManager();
    		$connection = $em->getConnection();
    		
    		$params = array(
    				'idUser'		=> $session->get('userId'),
    				'idProfile'		=> $session->get('userProfile'),
    				'trs_no_assig'	=> $this->getTrsNoAssig($session, $connection),
    				'trs_solic'		=> $this->getTrsSolic($session, $connection),
    				'trs_assig'		=> $this->getTrsAssig($session, $connection)
    		);
    		
    		return $this->render('adriwebubGermGranBundle::list.twig.html', $params);
    	}else{
    		return $this->redirect($this->generateUrl('AWUGG_error'), 301);
    	}
    }
    
    private function getTrsNoAssig($session, $connection){
    	
    	$sql = "SELECT *
		    	FROM tr
		    	WHERE id_tr_state = :id_tr_state";
    	
    	$statement = $connection->prepare($sql);
    	
    	$statement->bindValue('id_tr_state', 1);
    	$statement->execute();
    	$trs_no_assig = $statement->fetchAll();
    	
    	foreach ($trs_no_assig as $key=>$res){
    		
    		/* Recuperem els tutors del TR */
    		$sql = "SELECT u.name, u.last_name
		    		FROM user u
		    		INNER JOIN user_tr ut ON (ut.id_user = u.id)
		    		WHERE ut.id_tr = :id_tr";
    		
    		$statement = $connection->prepare($sql);
    		
    		$statement->bindValue('id_tr', $res['id']);
    		$statement->execute();
    		$users_tr = $statement->fetchAll();
    		
    		foreach($users_tr as $key2 => $u_res){
    			$trs_no_assig[$key]['tutors'][$key2] = $u_res['name'].' '.$u_res['last_name'];
    		}
    	}
    	
    	return $trs_no_assig;
    }
    
    private function getTrsSolic($session, $connection){

    	$sql = "SELECT *
		    	FROM tr
		    	WHERE id_tr_state = :id_tr_state";
    	 
    	$statement = $connection->prepare($sql);
    	
    	$statement->bindValue('id_tr_state', 2);
    	$statement->execute();
    	$trs_solic = $statement->fetchAll();
    	 
		foreach ($trs_solic as $key=> $res){
    		
    		/* Recuperem els tutors del TR */
    		$sql = "SELECT u.name, u.last_name
		    		FROM user u
		    		INNER JOIN user_tr ut ON (ut.id_user = u.id)
		    		WHERE ut.id_tr = :id_tr";
    		
    		$statement = $connection->prepare($sql);
    		
    		$statement->bindValue('id_tr', $res['id']);
    		$statement->execute();
    		$users_tr = $statement->fetchAll();
    		
    		foreach($users_tr as $key2 => $u_res){
    			$trs_solic[$key]['tutors'][$key2] = $u_res['name'].' '.$u_res['last_name'];
    		}
    	}
    	return $trs_solic;
    }
    
    private function getTrsAssig($session, $connection){
    	
    	$idUser = $session->get('userId');
    	
    	if($idUser == 1){
    		
    		/* Obtenim els Tr Assignats = Personals */
    		$sql = "SELECT tr.*
    				FROM tr
    				WHERE tr.id_tr_state IN (:id_tr_state)";
    			
    		$statement = $connection->prepare($sql);
    		$statement->bindValue('id_tr_state', '3');
    		
    	}else{
	    	/* Obtenim els Tr Assignats = Personals */
	    	$sql = "SELECT tr.*
			    	FROM tr
			    	INNER JOIN user_tr ut ON (ut.id_tr = tr.id)
			    	WHERE tr.id_tr_state IN (:id_tr_state)
	    				AND ut.id_user = :id_user";
	    	
	    	$statement = $connection->prepare($sql);
	    	$statement->bindValue('id_user', $session->get('userId'));
	    	$statement->bindValue('id_tr_state', '1, 3');
		}
    	
    	
    	$statement->execute();
    	$trs_assig = $statement->fetchAll();
		
    	foreach ($trs_assig as $key=> $res){
    		
    		/* Recuperem els tutors del TR */
    		$sql = "SELECT u.name, u.last_name
		    		FROM user u
		    		INNER JOIN user_tr ut ON (ut.id_user = u.id)
		    		WHERE ut.id_tr = :id_tr";
    		
    		$statement = $connection->prepare($sql);
    		
    		$statement->bindValue('id_tr', $res['id']);
    		$statement->execute();
    		$users_tr = $statement->fetchAll();
    		
    		foreach($users_tr as $key2 => $u_res){
    			$trs_assig[$key]['tutors'][$key2] = $u_res['name'].' '.$u_res['last_name'];
    		}
    	}
    	
    	return $trs_assig;
    }
    
    public function newtrAction(Request $request)
    {
    	$tr = new Tr();
    	
    	$form = $this->createFormBuilder($tr)
    	->add('name', 'text', array(
				'attr'=>array(
					'class'=>'form-control',
					'style'=>'margin-bottom:20px'),
				'label' => 'Nom'))
    	->add('code', 'text', array(
    			'attr'=>array(
					'class'=>'form-control',
    				'style'=>'margin-bottom:20px'),
    			'label' => 'Codi'))
    	->add('description', 'text', array(
    			'attr'=>array(
    				'class'=>'form-control',
    				'style'=>'margin-bottom:20px'),
    			'label' => 'Descripcio'))
    	->add('Guardar', 'submit', array(
    			'attr'=>array(
    				'class'=>'btn btn-primary')))
    	->getForm();
    	
    	$session = $request->getSession();
    	$session->start();
    	
    	return $this->render('adriwebubGermGranBundle::newtr.twig.html', array(
    			'form'	=> $form->createView(),
    			'idUser'=> $session->get('userId')
    	));
    }
    
    public function savetrAction(Request $request)
    {
    	if ($request->getMethod() == 'POST') {
    	
    		$form = $request->request->get('form');
    	
    		$tr = new Tr();
    	
    		$tr->setRegDate(new \DateTime("now"));
    		$tr->setName($form['name']);
    		$tr->setCode($form['code']);
    		$tr->setDescription($form['description']);
    		$tr->setIdTrState(1);
    		
    		$session = $request->getSession();
    		$session->start();
    		
    		$tr->setIdUser($session->get('userId'));
    	
    		$em = $this->getDoctrine()->getManager();
    		$em->persist($tr);
    		$em->flush();
			
    		$userTr = new UserTr();
    		
    		$userTr->setIdUser($session->get('userId'));
    		$userTr->setIdTr($tr->getId('id'));
    	
    		$em = $this->getDoctrine()->getManager();
    		$em->persist($userTr);
    		$em->flush();
    		
			$this->pujarCarpeta($request, $tr->getId());
			
    		return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    	}
    }
	
	private function pujarCarpeta($request, $id){
	
		$session = $request->getSession();
	    	$session->start();

		$access_token = $session->get('access_token');

		$url_array = explode('?', 'http://'.$_SERVER ['HTTP_HOST'].$_SERVER['REQUEST_URI']);
		$url = $url_array[0];

		$client = new \Google_Client();

		$client->setClientId('668478652001-5jqer4rs1cgdeh50lvcf91glvc2q5enp.apps.googleusercontent.com');
		$client->setClientSecret('IuMuKuYW6b1fhTnjWUj3IkUM');

		$client->setRedirectUri($url);
		$client->setScopes(array('https://www.googleapis.com/auth/drive'));

		if($access_token){
			$client->setAccessToken($access_token);
		}else{

			//session_start();

			if (isset($_GET['code'])) {
				//$_SESSION['accessToken'] = $client->authenticate($_GET['code']);
				$session->set('access_token', $client->authenticate($_GET['code']));
				header('location:'.$url.'?idTr='.$idTr);exit;
			} elseif (!isset($_SESSION['accessToken'])) {
				$client->authenticate();
			}

			//$client->setAccessToken($_SESSION['accessToken']);
			$client->setAccessToken($session->set('access_token'));
	
		}

		$service = new \Google_DriveService($client);
		$file = new \Google_DriveFile();
		
		$file_name = $id;
		$mime_type = "application/vnd.google-apps.folder";
		
		$file->setTitle($file_name);
		$file->setDescription('This is a '.$mime_type.' document');
		$file->setMimeType($mime_type);
		$service->files->insert($file);
	}
}
