<?php

namespace adriweb\ub\GermGranBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Session\Session;
use Symfony\Component\HttpFoundation\RedirectResponse;
use adriweb\ub\GermGranBundle\Entity\User;
use adriweb\ub\GermGranBundle\Entity\Consumer;

class RegisterController extends Controller
{
    public function indexAction()
    {
    
    	$user = new User();
    	
    	$form = $this->createFormBuilder($user)
    	->add('name', 'text', array(
				'attr'=>array(
					'class'=>'form-control',
					'style'=>'margin-bottom:20px'),
				'label' => 'Nom'))
    	->add('lastName', 'text', array(
    			'attr'=>array(
					'class'=>'form-control',
    				'style'=>'margin-bottom:20px'),
    			'label' => 'Cognoms'))
    	->add('dni', 'text', array(
    			'attr'=>array(
    				'class'=>'form-control',
    				'style'=>'margin-bottom:20px'),
    			'label' => 'DNI / NIE'))
    	->add('pass', 'text', array(
    			'attr'=>array(
    				'class'=>'form-control',
    				'style'=>'margin-bottom:20px'),
    			'label' => 'Constrasenya'))
	    ->add('idProfile', 'choice', array(
	    		'choices' => array(
	    			'1' => 'Professor',
	    			'2' => 'Alumne UB'),
	    		'multiple' => false,
	    		'expanded' => true,
	    		'required' => true,
	    		'attr'=>array(
	    			'style'=>'margin-bottom:10px'),
	    		'label' => 'Perfil'))
    	->add('Guardar', 'submit', array(
    			'attr'=>array(
    				'class'=>'btn btn-primary')))
    	->getForm();
    	
    	return $this->render('adriwebubGermGranBundle::register.twig.html', array(
    			'form' => $form->createView(),
    	));
    }
    
    public function saveAction(Request $request)
    {
    	
    	if ($request->getMethod() == 'POST') {

    		$form = $request->request->get('form');
    		
    		$user = new User();
    		
    		$user->setRegDate(new \DateTime("now"));
    		$user->setName($form['name']);
    		$user->setLastName($form['lastName']);
    		$user->setDni($form['dni']);
    		$user->setPass($form['pass']);
    		$user->setIdProfile($form['idProfile']);
    		
    		
    		$em = $this->getDoctrine()->getManager();
    		$em->persist($user);
    		$em->flush();
    		
		$repository = $this->getDoctrine()
    		->getRepository('adriwebubGermGranBundle:Consumer');
    		
	    	$consumer = $repository->find(1);

    		/* Session init */
    		$session = new Session();
    		$session->start();
    		
    		/* Session charge */
    		$session->set('userId', $user->getId());
    		$session->set('userName', $user->getName());
    		$session->set('userLastName', $user->getLastName());
    		$session->set('userProfile', $user->getIdProfile());
    		if($consumer->getAccessToken()){
			$session->set('access_token', $consumer->getAccessToken());
		}

    		return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    	}
    }
}
