<?php

namespace adriweb\ub\GermGranBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Session\Session;

use adriweb\ub\GermGranBundle\Entity\Tr;
use adriweb\ub\GermGranBundle\Entity\UserTr;
use adriweb\ub\GermGranBundle\Entity\User;

require_once 'google/google-api-php-client/src/Google_Client.php';
require_once 'google/google-api-php-client/src/contrib/Google_DriveService.php';

class TrController extends Controller
{
    public function viewAction(Request $request)
    {
    	
    	$session = $request->getSession();
    	$session->start();
    	
    	if($session->get('userId')){
    		
    		$idTr = $request->query->get('idTr');

    		$repository = $this->getDoctrine()
    		->getRepository('adriwebubGermGranBundle:Tr');
    		
	    	$tr = $repository->find($idTr);
	    	
	    	if (!$tr) {
	    		
	    		return $this->redirect($this->generateUrl('AWUGG_error'), 301);
	    	}
    		
    		$params = array(
    				'idUser'		=> $session->get('userId'),
    				'idProfile'		=> $session->get('userProfile'),
    				'tr'			=> $tr,
    				'documents'		=> ''
    		);
    		
    		$em = $this->getDoctrine()->getManager();
    		$connection = $em->getConnection();
    		
    		/* Recuperem l'usuari que ha solcitat el TR */
    		$sql = "SELECT u.id, u.name, u.last_name
		    		FROM user u
		    		INNER JOIN user_tr ut ON (ut.id_user = u.id)
		    		INNER JOIN tr ON (tr.id = ut.id_tr)
		    		WHERE ut.id_tr = :id_tr
    					AND ut.id_user <> tr.id_user
    					AND u.id_profile = 2
    				LIMIT 1";
    		
    		$statement = $connection->prepare($sql);

    		$statement->bindValue('id_tr', $idTr);
    		$statement->execute();
    		$users_tr = $statement->fetchAll();
    		
    		$params['sollicitud'] = null;
    		$params['idSolicitant'] = null;
    		if($users_tr){
	    		$params['sollicitud'] = $users_tr[0]['name'].' '.$users_tr[0]['last_name'];
	    		$params['idSolicitant'] = $users_tr[0]['id'];
    		}

    		$params['files'] = null;
    		if($tr->getIdTrState() == 3) $params['files'] = $this->getRecursos($request, $tr->getId());
			
    		return $this->render('adriwebubGermGranBundle::viewtr.twig.html', $params);
    	}else{
    		return $this->redirect($this->generateUrl('AWUGG_error'), 301);
    	}
    }
    
    public function sollicitarAction(Request $request){
    	
    	$session = $request->getSession();
    	$session->start();
    	
    	$idTr = $request->query->get('idTr');
    	$idUser = $request->query->get('idUser');
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:Tr');
    	
    	$tr = $repository->find($idTr);
    	$tr->setIdTrState(2);
    	
    	$em = $this->getDoctrine()->getManager();
    	$em->persist($tr);
    	$em->flush();
    	
    	$userTr = new UserTr();
    	
    	$userTr->setIdUser($session->get('userId'));
    	$userTr->setIdTr($idTr);
    	 
    	$em = $this->getDoctrine()->getManager();
    	$em->persist($userTr);
    	$em->flush();
    	
    	return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    }
    
    public function acceptarAction(Request $request){
    	 
    	$idTr = $request->query->get('idTr');
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:Tr');
    	 
    	$tr = $repository->find($idTr);
    	$tr->setIdTrState(3);
    	 
    	$em = $this->getDoctrine()->getManager();
    	$em->persist($tr);
    	$em->flush();
    	
    	return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    }
    
    public function denegarAction(Request $request){
    	 
    	$idTr = $request->query->get('idTr');
    	$idUser = $request->query->get('idUser');
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:Tr');
    	
    	$tr = $repository->find($idTr);
    	$tr->setIdTrState(1);
    	
    	$em = $this->getDoctrine()->getManager();
    	$em->persist($tr);
    	$em->flush();
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:UserTr');

    	$userTr = $repository->findBy(array('idTr' => $idTr, 'idUser' => $idUser));
    	
    	$em = $this->getDoctrine()->getManager();
    	$em->remove($userTr[0]);
    	$em->flush();
    	
    	return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    }
    
    public function modificarAction(Request $request){
    	
    	$idTr = $request->query->get('idTr');
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:Tr');
    	
    	$tr = $repository->find($idTr);
    	
    	$form = $this->createFormBuilder($tr)
    	->add('name', 'text', array(
    			'attr'=>array(
    					'class'=>'form-control',
    					'style'=>'margin-bottom:20px'),
    			'label' => 'Nom'))
    	->add('code', 'text', array(
    			'attr'=>array(
    					'class'=>'form-control',
    					'style'=>'margin-bottom:20px'),
    			'label' => 'Codi'))
    	->add('description', 'text', array(
    			'attr'=>array(
    					'class'=>'form-control',
    					'style'=>'margin-bottom:20px'),
    			'label' => 'Descripcio'))
    	->add('id', 'hidden', array(
    			'data' => $idTr)
    			)
    	->add('Guardar', 'submit', array(
    			'attr'=>array(
    					'class'=>'btn btn-primary')))
    	->getForm();
    	 
    	$session = $request->getSession();
    	$session->start();
    	 
    	return $this->render('adriwebubGermGranBundle::modiftr.twig.html', array(
    			'form'	=> $form->createView(),
    			'idUser'=> $session->get('userId')
    	));
    }
    
    public function modiftrAction(Request $request){
    	
    	if ($request->getMethod() == 'POST') {
    		 
    		$form = $request->request->get('form');
    		
    		$idTr = $form['id'];
    	
	    	$repository = $this->getDoctrine()
	    	->getRepository('adriwebubGermGranBundle:Tr');
	    	
	    	$tr = $repository->find($idTr);
    		 
    		$tr->setRegDate(new \DateTime("now"));
    		$tr->setName($form['name']);
    		$tr->setCode($form['code']);
    		$tr->setDescription($form['description']);
    	
    		 
    		$em = $this->getDoctrine()->getManager();
    		$em->persist($tr);
    		$em->flush();
    	
    		$params = array('idTr' => $idTr);
    		
    		return $this->redirect($this->generateUrl('AWUGG_tr_view', $params), 301);
    	}
    }
    
    public function eliminarAction(Request $request){

    	$idTr = $request->query->get('idTr');
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:UserTr');
    	
    	$userTr = $repository->findBy(array('idTr' => $idTr));
    	 
    	$em = $this->getDoctrine()->getManager();
    	
    	foreach($userTr as $utr){
	    	$em->remove($utr);
	    	$em->flush();
    	}
    	
    	$repository = $this->getDoctrine()
    	->getRepository('adriwebubGermGranBundle:Tr');
    	 
    	$tr = $repository->findBy(array('id' => $idTr));
    	
    	$em = $this->getDoctrine()->getManager();
    	$em->remove($tr[0]);
    	$em->flush();
    	
    	return $this->redirect($this->generateUrl('AWUGG_list'), 301);
    }
	
	private function getRecursos(Request $request, $idTr){
		
		$session = $request->getSession();
	    $session->start();
	    
		$access_token = $session->get('access_token');

		$url_array = explode('?', 'http://'.$_SERVER ['HTTP_HOST'].$_SERVER['REQUEST_URI']);
		$url = $url_array[0];

		$client = new \Google_Client();

		$client->setClientId('668478652001-5jqer4rs1cgdeh50lvcf91glvc2q5enp.apps.googleusercontent.com');
		$client->setClientSecret('IuMuKuYW6b1fhTnjWUj3IkUM');

		$client->setRedirectUri($url);
		$client->setScopes(array('https://www.googleapis.com/auth/drive'));

		if($access_token){
			$client->setAccessToken($access_token);
		}else{

			//session_start();

			if (isset($_GET['code'])) {
				//$_SESSION['accessToken'] = $client->authenticate($_GET['code']);
				$session->set('access_token', $client->authenticate($_GET['code']));
				header('location:'.$url.'?idTr='.$idTr);exit;
			} elseif (!isset($_SESSION['accessToken'])) {
				$client->authenticate();
			}

			//$client->setAccessToken($_SESSION['accessToken']);
			$client->setAccessToken($session->set('access_token'));
		
		}
		

		$service = new \Google_DriveService($client);
		$fitxers = $service->files->listFiles(array());

		foreach($fitxers['items'] as $f){	
			
			if($f['title'] == $idTr){
				$id = $f['id'];
			}
		}

		$fitxers = $service->children->listChildren($id);
		$f = array();
		
		foreach($fitxers['items'] as $fitxer){	
			
			$f[] = $service->files->get($fitxer['id']);
		}
		
		return $f;

	}
	
	public function pujarAction(Request $request){
	
		$idTr = $request->query->get('idTr');
		
		$this->uploadFile($request, $idTr);
		
		$params = array('idTr' => $idTr);
		
    	return $this->redirect($this->generateUrl('AWUGG_tr_view', $params), 301);
	
	}
	
	private function uploadFile($request, $id){
	
		if (!empty($_FILES)) {
		
			$session = $request->getSession();
		    	$session->start();
			$access_token = $session->get('access_token');

			$url_array = explode('?', 'http://'.$_SERVER ['HTTP_HOST'].$_SERVER['REQUEST_URI']);
			$url = $url_array[0];

			$client = new \Google_Client();

			$client->setClientId('668478652001-5jqer4rs1cgdeh50lvcf91glvc2q5enp.apps.googleusercontent.com');
			$client->setClientSecret('IuMuKuYW6b1fhTnjWUj3IkUM');

			$client->setRedirectUri($url);
			$client->setScopes(array('https://www.googleapis.com/auth/drive'));

			if($access_token){
				$client->setAccessToken($access_token);
			}else{

				//session_start();

				if (isset($_GET['code'])) {
					//$_SESSION['accessToken'] = $client->authenticate($_GET['code']);
					$session->set('access_token', $client->authenticate($_GET['code']));
					header('location:'.$url.'?idTr='.$id);exit;
				} elseif (!isset($_SESSION['accessToken'])) {
					$client->authenticate();
				}

				//$client->setAccessToken($_SESSION['accessToken']);
				$client->setAccessToken($session->set('access_token'));
		
			}

			$service = new \Google_DriveService($client);
			$fitxers = $service->files->listFiles(array());

			foreach($fitxers['items'] as $f){	
				
				if($f['title'] == $id){
					$parentId = $f['id'];
				}
			}
		
			$client->setAccessToken($access_token);
			$service = new \Google_DriveService($client);
			$file = new \Google_DriveFile();
		
			// Set the parent folder.
			if ($parentId != null) {
				$parent = new \Google_ParentReference();
				$parent->setId($parentId);
				$file->setParents(array($parent));
			}
			
			$file_name = $_FILES['file1']['name'];
			$mime_type = $_FILES['file1']['type'];
			
			$file->setTitle($file_name);
			$file->setDescription('This is a '.$mime_type.' document');
			$file->setMimeType($mime_type);
			$service->files->insert(
				$file,
				array(
					'data' => file_get_contents($_FILES["file1"]["tmp_name"]),
					'mimeType' => $mime_type
				));
		
		}
		
	}
	
	public function afegirAluAction(Request $request){
		
		$idTr = $request->query->get('idTr');
		 
		$user = new User();
		 
		$form = $this->createFormBuilder($user)
		->add('name', 'text', array(
				'attr'=>array(
						'class'=>'form-control',
						'style'=>'margin-bottom:20px'),
				'label' => 'Nom'))
		->add('lastName', 'text', array(
				'attr'=>array(
						'class'=>'form-control',
						'style'=>'margin-bottom:20px'),
				'label' => 'Cognoms'))
		->add('dni', 'text', array(
				'attr'=>array(
						'class'=>'form-control',
						'style'=>'margin-bottom:20px'),
				'label' => 'DNI / NIE'))
		->add('pass', 'text', array(
				'attr'=>array(
						'class'=>'form-control',
						'style'=>'margin-bottom:20px'),
				'label' => 'Constrasenya'))
		->add('Guardar', 'submit', array(
				'attr'=>array(
						'class'=>'btn btn-primary')))
		->getForm();
		 
		return $this->render('adriwebubGermGranBundle::registerAlu.twig.html', array(
				'form' => $form->createView(),
				'idTr' => $idTr,
		));
	}
	
	public function afegirAluSaveAction(Request $request){
		
		$idTr = $request->query->get('idTr');
		
		if ($request->getMethod() == 'POST') {
		
			$form = $request->request->get('form');
		
			$user = new User();
		
			$user->setRegDate(new \DateTime("now"));
			$user->setName($form['name']);
			$user->setLastName($form['lastName']);
			$user->setDni($form['dni']);
			$user->setPass($form['pass']);
			$user->setIdProfile(3);
		
		
			$em = $this->getDoctrine()->getManager();
			$em->persist($user);
			$em->flush();
			
			$userTr = new UserTr();
			
			$userTr->setIdUser($user->getId());
			$userTr->setIdTr($idTr);
			 
			$em = $this->getDoctrine()->getManager();
			$em->persist($userTr);
			$em->flush();
		
			return $this->redirect($this->generateUrl('AWUGG_list'), 301);
		}
	}
}
